#!/usr/bin/python
# -*- coding: iso-8859-1 -*-

# This file is part of Oidua.
#
# Oidua is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Copyright 2003	Sylvester Johansson 	(sylvestor@telia.com)
#			Mattias Pivrinta	(mpa99001@student.mdh.se)

import sys,string,re,os,time,audiotype

version = "0.12"

def sorted(fulldir, pattern):
	temp = []
	for x in fulldir:
		if re.search(pattern, x):
			temp.append(x)
	return temp
def average(listofbr):
	temp = 0
	for x in listofbr:
		temp += x
	return temp/len(listofbr)
def vbrchecker(vbrlist):
	if len(vbrlist) == 1:
		if (vbrlist[0] == 0):
			return "CBR"
		if (vbrlist[0] == 1):
			return "VBR"
	else:
		return "C/VBR"
	
def outputter(header, outputfolder = "", albumsize = 0.0, bitrates = 0, vbrcheck = "", filetype=""):
	if header == 0: #top header
		outputstring = "%-" + str(crop - 29)+ "s %6s %s %-9s %s %s"
		print outputstring%("Album/Artist","Mb",'|',"Kb/s",'|',"Format")		
	if header == 1: #separator
		print ("="* (crop - 21))+'+'+("="*11)+'+'+("="*7)
	if header == 2: #dir with audio
		outputstring = "%-" + str(crop - 29) + "s %6.2f %s %3d %-5s %s %s"
		print outputstring%(outputfolder[:crop-30],albumsize,'|',bitrates,vbrcheck,'|',filetype)
	if header == 3: #dir w/o audio
		outputstring = "%-" + str(crop - 22) + "s %s %9s %s"
		print outputstring%(outputfolder[:crop-30],'|','','|')
	if header == 4: #date
		outputstring = "%" + str(crop) + "s"
		print outputstring%(time.asctime(time.localtime()))

def fileformat(formats):
	back = []
	if len(formats)<3:
		for x in formats:
			if x == 0:
				try:
					back.index("OGG")
				except:
					back.append("OGG")
			if x == 1:
				try:
					back.index("MP3")
				except:
					back.append("MP3")
			if x == 2:
				try:
					back.index("MPC")
				except:
					back.append("MPC")
	else:
		back.append("ALL")
	return string.join(back,",")
			
def grab(folder):
	temp = os.listdir(folder)
	files = []
	for x in temp:
		if os.path.isfile(os.path.join(folder,x)):
			files.append(x)
		
	bitrates = []
	albumsize = 0.0
	format = []
	vbrtuple = []
	for x in sorted(files, "((ogg|OGG)|(mpc|MPC)|(mp3|MP3))\Z"):
		if(string.lower(x[-3:]) == "mp3"):
			file = audiotype.MP3(os.path.join(folder,x))
		if(string.lower(x[-3:]) == "mpc"):
			file = audiotype.MPC(os.path.join(folder,x))
		if(string.lower(x[-3:]) == "ogg"):
			file = audiotype.OGG(os.path.join(folder,x))
		albumsize += file.size
		bitrates.append(file.bitrate)
		try:
			format.index(file.format)
		except:
			format.append(file.format)
		try:
			vbrtuple.index(file.vbr)
		except:
			vbrtuple.append(file.vbr)
			
	outputfolder = "   " * (string.count(folder,os.sep) - BASE) + os.path.split(folder)[-1]
	if(len(bitrates)!=0):
		outputter(2, outputfolder, (albumsize/(1024*1024)), average(bitrates), vbrchecker(vbrtuple), fileformat(format))
	else:
		outputter(3,outputfolder)
def smash(found):
	test = os.listdir(found)
	test.sort()
	for x in test:
		next = os.path.join(found,x)
		try:
			if excludepath:
				try:
					excludepath.index(next)
					
				except:
					grab(next)
					smash(next)
			else:
				grab(next)
				smash(next)
		except:
			pass



start = time.clock()
DispVersion = 0
DispTime = 0
DispHelp = 0
DispDate = 0
folders = []
excludepath = []
crop = 80

for x in sys.argv:
	if x == "-t":
		DispTime = 1
	if x == "-V":
		DispVersion = 1
	if x == "-D":
		DispDate = 1
	if x == "-h":
		DispHelp = 1
	if x == "-C":
		try:
			crop = string.atoi(sys.argv[sys.argv.index("-C")+1])
		except:
			print sys.argv[sys.argv.index("-C")+1],"is not a number"
if sys.argv.count("-e"):
	try:
		excludepath = sys.argv[sys.argv.index("-e")+1:sys.argv.index("--")]
		folders = sys.argv[sys.argv.index("--")+1:]
	except:
		print "No -- switch found"
else:
	for x in sys.argv:
		if os.path.isdir(x):
			folders.append(x)
	

if DispDate == 1:
	outputter(4)
if folders:
	outputter(0)
	for x in folders:
		outputter(1)
		x = os.path.abspath(x)
		BASE = string.count(x[:-1],os.sep)
		grab(x)
		smash(x)
else:
	DispHelp = 1



if DispHelp:
	print "Usage:\toidua.py [switches] [-e <path> ... --] <basedir> ..."
	print "\t-V\tDisplay version"
	print "\t-t\tDisplay timestamp"
	print "\t-C <x>\tSet cropping to x"
	print "\t-D\tDisplay datestamp"
	print "\t-e <x>\tExclude path x from search"
if DispTime:
	print "%-10s %5.2f %s"%("\ntime: ",time.clock() - start, "s")
if DispVersion:
	print "\n%-20s %s\n%-20s %s"%("oidua version: ",version,"Audiotype version: ",audiotype.version)
